#
#    Project: The EDNA Kernel
#             http://www.edna-site.org
#
#    File: "$Id: EDApplicationCheckPlugin.py 664 2009-05-06 13:05:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib import EDString
from EDImportLib import EDVerbose
from EDImportLib import EDDictionary

from EDApplication    import EDApplication

from EDUtilsFile import EDUtilsFile
from EDUtilsPath import EDUtilsPath
from EDUtilsTest import EDUtilsTest


class EDApplicationCheckPlugin( EDApplication ):
    """
    """
    
    def preProcessAction( self ):
        """
        """
        edDictionary = EDDictionary()
        edDictionary.setValue("${EDNA_TESTS_DATA_HOME}", EDUtilsTest.getTestsDataHome() )
        edDictionary.setValue("${EDNA_HOME}", EDUtilsPath.getEdnaHome() )

        strXMLData = EDUtilsFile.readFileAndParseVariables( self.getDatasetFileName(), edDictionary )
        self.m_edStringXMLData = EDString( strXMLData )
        
        
    def postProcessAction( self ):
        """
        """
        outputDataFile = self.getPlugin().getPluginName() + "_output.xml"
        EDVerbose.DEBUG("*** EDApplicationCheckPlugin.retrievePluginOutputData: Getting Output Data of : " + self.getPlugin().getPluginName() )
        self.m_xsDataOutput = self.getPlugin().getDataOutput()

        if ( self.m_xsDataOutput != None):
            self.m_xsDataOutput.outputFile( outputDataFile )
            strOutput = EDUtilsFile.readFileAndParseVariable( outputDataFile, "${EDNA_TESTS_DATA_HOME}", EDUtilsTest.getTestsDataHome() )
        else:
            EDVerbose.error( "*** EDApplicationCheckPlugin.retrievePluginOutputData: Output Data is None" )
        
        
    
    