#
#    Project: The EDNA Kernel
#             http://www.edna-site.org
#
#    File: "$Id: EDTestCaseEDFactoryPlugin.py 664 2009-05-06 13:05:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib         import EDCompiler
from EDImportLib         import EDVerbose
from EDImportLib         import EDDiskExplorer
from EDImportLib         import EDString
from EDImportLib         import EDList

from EDTestCase          import EDTestCase
from EDUtilsFile         import EDUtilsFile
from EDUtilsTable        import EDUtilsTable
from EDAssert            import EDAssert

from EDFactoryPlugin import EDFactoryPlugin

class EDTestCaseEDFactoryPlugin( EDTestCase ):
    """
    """
    
    def __init__( self, _edStringTestName = None):
        """
        """
        EDTestCase.__init__( self, _edStringTestName )
        self.m_edConfiguration = None
        
        
    def testLoadPlugin( self ):
        edFactoryPlugin = EDFactoryPlugin()
        #edPluginTest = edFactoryPlugin.loadPlugin( "EDPluginMOSFLMv01Indexing" )
        edPluginTest = edFactoryPlugin.loadPlugin( "EDPluginTestEDPluginFactoryPlugin" )
        
##############################################################################

    def process( self ):
        """
        """
        self.addTestMethod( self.testLoadPlugin )



##############################################################################

if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestCaseEDFactoryPlugin = EDTestCaseEDFactoryPlugin( "EDTestCaseEDFactoryPlugin" )
    edTestCaseEDFactoryPlugin.execute()
