#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALActionSetAsynchronous     import  ALActionSetAsynchronous


class ALActionCluster( ALActionSetAsynchronous ):
    """
    Parent class for all ALActionCluster.

    By default: a cluster of 64 parallel task are executed at the same time

    The methods to be modified by the user (overload):
        def preProcess( self, _oalObject = None )
        def postProcess( self, _oalObject = None )
    """
    def __init__( self, _oiClusterSize = 64 ):
        """
        Constructor for ALActionCluster.
        """
        ALActionSetAsynchronous.__init__( self )
        self.setClusterSize( _oiClusterSize )


    def process( self, _oalObject = None ):
        """
        This is the main method of the action cluster.
        """

        for iAction in self.m_oalListAction :
            self.actionControl()

            self.synchronizeOn()
            iAction.connectSUCCESS( self.controlActionSuccess )
            iAction.connectFAILURE( self.controlActionFailure )

            iAction.execute( _oalObject )
            self.synchronizeOff()

            # It controls the end of the cluster actions
            self.synchronizeCluster()

        # It waits the end of all actions
        self.synchronizeController()




##############################################################################

