#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################



from ALDefinition                import *
from ALVerbose                   import ALVerbose
from ALAppDefinitionCore         import ALAppDefinitionCore


class ALApplication( ALAppDefinitionCore ):
    """
    Basic Interface for Application objects.

    """
    def __init__( self, _oalString = AL_FRAMEWORK_APPLICATION_NAME, _dversion = AL_VERSION, _obPlugin = True ):
        ALAppDefinitionCore.__init__( self, _oalString, _dversion, _obPlugin )



############################################################################
# This methods can be modified by the user
############################################################################


    def preProcess( self ):
        """
        Any processing that must occur before the main ALApplication loop
        """
        ALApplication.synchronizeOn()
        ALVerbose.aalibDEBUG( "Execution: ALApplication.preProcess()" )
        ALApplication.synchronizeOff()


    def process( self ):
        """
        This is the main method of the ALApplication.
        """
        ALApplication.synchronizeOn()
        ALVerbose.aalibDEBUG( "Execution: ALApplication.process()" )
        ALApplication.synchronizeOff()


    def postProcess( self ):
        """
        This is the final method executed by the application
        """
        ALApplication.synchronizeOn()
        ALVerbose.aalibDEBUG( "Execution: ALApplication.postProcess()" )
        ALApplication.synchronizeOff()



##############################################################################


