#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALObject                 import ALObject
from ALThreadingCondition     import ALThreadingCondition


class ALApplicationCommunicator( ALObject ):
    """
    Parent class.
    """

    m_oalSignal = None
    m_oalThreadingConditionALApplicationCommunicator = ALThreadingCondition()

    def __init__( self,  ):
        ALObject.__init__( self )


    def synchronizeOn():
        ALApplicationCommunicator.m_oalThreadingConditionALApplicationCommunicator.synchronizeOn()
    synchronizeOn = staticmethod( synchronizeOn )


    def synchronizeOff():
        ALApplicationCommunicator.m_oalThreadingConditionALApplicationCommunicator.synchronizeOff()
    synchronizeOff = staticmethod( synchronizeOff )


    def getSignal():
        ALApplicationCommunicator.synchronizeOn()
        oalSignal = None
        if ALApplicationCommunicator.m_oalSignal != None :
            oalSignal = ALApplicationCommunicator.m_oalSignal.clone()
        ALApplicationCommunicator.synchronizeOff()
        return oalSignal
    getSignal = staticmethod( getSignal )


    def setSignal( _oalObject ):
        ALApplicationCommunicator.synchronizeOn()
        if _oalObject != None :
            ALApplicationCommunicator.m_oalSignal = _oalObject.clone()
        ALApplicationCommunicator.synchronizeOff()
    setSignal = staticmethod( setSignal )



##############################################################################
