#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################



from ALDefinition                import *
from ALVerbose                   import ALVerbose
from ALApplication               import ALApplication
from ALServerXmlRpc              import ALServerXmlRpc



class ALApplicationServerXmlRpc( ALApplication ):
    """
    Interface for Application objects.

    """


    def __init__( self, _oalString = AL_FRAMEWORK_APPLICATION_NAME, _oalHost = "localhost",
                 _oalSocket = 8888, _dversion = AL_VERSION ):
        ALApplication.__init__( self, _oalString, _dversion )
        self.m_oalServerXmlRpc = ALServerXmlRpc( _oalHost, _oalSocket )


    def addObject( self, _oalObject ):
        self.m_oalServerXmlRpc.addObject( _oalObject )


    def addMethod( self, _oalMethod ):
        self.m_oalServerXmlRpc.addMethod( _oalMethod )


    def addServerControlInterface( self, _oalObject ):
        self.addObject( _oalObject )


    def process( self ):
        """
        This is the main method of the application.
        """
        ALApplication.synchronizeOn()
        ALVerbose.aalibDEBUG( "Execution: ALApplicationServerXmlRpc.process()" )
        self.m_oalServerXmlRpc.executeServer()
        ALApplication.synchronizeOff()



##############################################################################
