#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython            import PyOS
from ALObject                  import ALObject
from ALString                  import ALString
from ALList                    import ALList
from ALDiskExplorer            import ALDiskExplorer



class ALFile( ALObject ):
    """
    Interface for AL thread objects.
    """
    def __init__( self, _oalString = "None"  ):
        pass


    def exist( _oalString ):
        return PyOS.path.isfile( ALDiskExplorer.normalize( _oalString ) )
    exist = staticmethod( exist )


    def getExtension( _oalString ):
        oalList = ALList( PyOS.path.splitext( ALDiskExplorer.normalize( _oalString ) ) )
        iLenght = len( oalList )
        oalString = ALString( oalList[iLenght-1] )
        return oalString
    getExtension = staticmethod( getExtension )


    def setExtension( _oalStrFile, _oalStrExt ):
        """
        You must provide a complete extension name
        """
        oalList = ALList( PyOS.path.splitext( ALDiskExplorer.normalize( _oalStrFile ) ) )
    	oalString2 = ALString()
    	for i in range( len( oalList )-1 ):
                oalString2 = oalString2 + ALString( oalList[i] )
    	#oalString2 = oalString2 + "." + _oalStrExt
    	oalString2 = oalString2 + _oalStrExt
    	return oalString2
    setExtension = staticmethod( setExtension )


    def isExtension( _oalStrFileName, _oalStrExtension ):
        #if ALFile.exist( _osStrFileName )==False:
        #    return False
        #
        if ALFile.getExtension( _oalStrFileName )==_oalStrExtension:
            return True
        else:
            return False
    isExtension = staticmethod( isExtension )



    # Dir List + FileName with extension
    def getListName( _oalString ):
        oalString = PyOS.path.dirname( _oalString )
        if (oalString == ".." ):
            oalString = ALString( PyOS.getcwd() )
            oalString = ALDiskExplorer.normalize( PyOS.path.dirname( oalString ) )
            oalString = oalString + "/" + ALFile.getFileName( _oalString )
        else:
            oalString = ALDiskExplorer.normalize( _oalString )

        oalList = ALList( oalString.split( "/" ) )
        return oalList
    getListName = staticmethod( getListName )


    # Without extension
    def getBaseName( _oalString ):
        oalString = ALString( PyOS.path.basename( ALDiskExplorer.normalize( _oalString ) ) )
        oalList = ALList( PyOS.path.splitext( ALDiskExplorer.normalize( oalString ) ) )
        oalString2 = ALString()
        for i in range( len( oalList )-1 ):
            oalString2 = oalString2 + ALString( oalList[i] )
        return oalString2
    getBaseName = staticmethod( getBaseName )


    # File name + extesion = NO PATH
    def getFileName( _oalString ):
       return ALString( PyOS.path.basename( ALDiskExplorer.normalize( _oalString ) ) )
    getFileName = staticmethod( getFileName )



    def getFolderName( _oalString ):
        oalString = PyOS.path.dirname( _oalString )
        return ALDiskExplorer.normalize( oalString )
    getFolderName = staticmethod( getFolderName )



##############################################################################
#  http://en.wikipedia.org/wiki/File_name:
#  Filename
#  From Wikipedia, the free encyclopedia
#  (Redirected from File name)
#  Jump to: navigation, search
#
#  A filename is a special kind of string used to uniquely identify a file stored on the file system of a computer.
#  Different operating systems impose different restrictions regarding length and allowed characters on filenames.
#  The address (unique resource identifier - URI) of a file includes at least one or more of these components:
#
#    * host (or network-ID) ? host name, IP address, domain name, or LAN network name (e.g., wikipedia.org, 207.142.131.206, \\MYCOMPUTER, PS:, etc.)
#    * device (or node) ? drive, root mountpoint, disc, volume (e.g., C:, /, SYSLIB, etc.)
#    * directory (or path) ? directory tree (e.g., /usr/bin, \TEMP, [USR.LIB.SRC], etc.)
#    * file ? base name of the file
#    * type (or extension) ? indicates the content type of the file (e.g., .txt, .exe, .dir, etc.)
#    * version ? revision number of the file
