#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALTime         import ALTime
from ALInformation  import ALInformation


class ALInformationAction( ALInformation ):
    """
    Interface for action information.
    """
    def __init__( self, _oalActionID, _oalAction ):
        ALInformation.__init__( self )
        self.m_oalActionID     = _oalActionID
        self.m_oalAction       = _oalAction
        self.m_oalActionName   = _oalAction.getName()
        self.m_obIsRunning     = True


    def setActionEnd( self ):
        self.setTimeEnd()
        self.synchronizeOn()
        self.m_obIsRunning = False
        self.synchronizeOff()


    def isRunning( self ):
        self.synchronizeOn()
        obStatus = self.m_obIsRunning
        self.synchronizeOff()
        return obStatus


    def getActionID( self ):
        self.synchronizeOn()
        oalID = self.m_oalActionID
        self.synchronizeOff()
        return oalID


    def getActionName( self ):
        self.synchronizeOn()
        oName = self.m_oalActionName
        self.synchronizeOff()
        return oName


    def forceActionClose( self ):
        self.m_oalAction.close()



##############################################################################
