#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#    Copyright (C) 2005-2008  Romeu Andre Pieritz (romeu.pieritz@gmail.com)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################



ALPROFILE_TEMPLATE_TIMELINE = """\
<html>
  <head>
    <title> %(_pageName)s </title>

    <link rel="stylesheet" href="%(_folderName)s/styles.css" type="text/css">
    <link rel="stylesheet" href="%(_folderName)s/bundle.css" type="text/css">

    <script src="%(_folderName)s/timeline-api.js?local" type="text/javascript"></script>
    <script src="%(_folderName)s/bundle.js?local"       type="text/javascript"></script>
    <script src="%(_folderName)s/timeline.js?local"     type="text/javascript"></script>
    <script src="%(_folderName)s/labellers.js?local"    type="text/javascript"></script>

    <script>
        var tl;
        function onLoad() {
          var eventSource = new Timeline.DefaultEventSource();
          var theme = Timeline.ClassicTheme.create();
          theme.event.bubble.width  = 400;
          theme.event.bubble.height = 100;
          theme.ether.backgroundColors[1] = theme.ether.backgroundColors[0];

          var bandInfos = [
            Timeline.createBandInfo({
                eventSource:    eventSource,
                date:           "%(_dataInit)s",
                width:          "%(_widthZone1)s",
                intervalUnit:   Timeline.DateTime.SECOND,
                intervalPixels: 100,
                theme:          theme

            }),
            Timeline.createBandInfo({
                showEventText:  false,
                trackHeight:    0.5,
                trackGap:       0.2,
                eventSource:    eventSource,
                date:           "%(_dataInit)s",
                width:          "%(_widthZone2)s",
                intervalUnit:   Timeline.DateTime.MINUTE,
                intervalPixels: 200,
                theme:          theme

            }),
            Timeline.createBandInfo({
                showEventText:  false,
                trackHeight:    0.5,
                trackGap:       0.2,
                eventSource:    eventSource,
                date:           "%(_dataInit)s",
                width:          "%(_widthZone3)s",
                intervalUnit:   Timeline.DateTime.HOUR,
                intervalPixels: 200,
                theme:          theme

            })
          ];

          bandInfos[1].syncWith = 0;
          bandInfos[1].highlight = true;
          bandInfos[1].eventPainter.setLayout(bandInfos[0].eventPainter.getLayout());
          bandInfos[2].syncWith = 0;
          bandInfos[2].highlight = true;
          bandInfos[2].eventPainter.setLayout(bandInfos[1].eventPainter.getLayout());


          for (var i = 0; i < bandInfos.length; i++) {
                bandInfos[i].decorators = [
                    new Timeline.SpanHighlightDecorator({
                        startDate:  "%(_dataInit)s",
                        color:      "#FFC080",
                        opacity:    50,
                        theme:      theme
                    }),
                    new Timeline.PointHighlightDecorator({
                        date:       "%(_dataInit)s",
                        color:      "#FFC080",
                        opacity:    50,
                        theme:      theme
                    }),
                    new Timeline.PointHighlightDecorator({
                        date:       "%(_dataInit)s",
                        color:      "#FFC080",
                        opacity:    50,
                        theme:      theme
                    })
                ];
            }


          tl = Timeline.create(document.getElementById("profile-timeline"), bandInfos, Timeline.HORIZONTAL);
          Timeline.loadXML("%(_dataFileNameXml)s", function(xml, url) { eventSource.loadXML(xml, url); });

        }

        var resizeTimerID = null;
        function onResize() {
            if (resizeTimerID == null) {
                resizeTimerID = window.setTimeout(function() {
                    resizeTimerID = null;
                    tl.layout();
                }, 500);
            }
        }

    </script>


  </head>
  <body onload="onLoad();" onresize="onResize();">

  <ul id="path">
  <li><a href="http://jyaalib.sourceforge.net" title="Home">PyAALib-JyAALib</a></li>
  <li><span>Visual Profile V0.9</span></li>
  </ul>

  <div id="body">
    <h1>%(_pageName)s </h1>

    <a href="%(_folderName)s/system.txt" >[SYSTEM Information]</a> <br>
    Drag the cursor over the plot, or double click on the tables, or click on the event - blue=SUCCESS, green=TAG-DEBUG or red=EXCEPTION<br>

    <div id="profile-timeline" class="timeline-default" style="height: 500px; margin: 2em;"></div>

    <br>
    Designed by R.A.Pieritz - Copyright PyAALib-JyAALib - 2008 <a href="http://jyaalib.sourceforge.net">http://jyaalib.sourceforge.net</a><br>
    Based on SIMILE Timeline Project - <a href="http://simile.mit.edu/timeline/">http://simile.mit.edu/timeline/</a><br>
    Best view on Firefox Browser<br>

  </div>
  </body>
</html>
"""




##############################################################################


