#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from    ALImportPython import  PyRandom
from    ALMetaObject   import  ALMetaObject


class ALRandom( ALMetaObject ):
    """
    Interface for AL random generator object.

    """

    def __init__( self ):
        ALMetaObject.__init__( self )

    def __call__( self ):
        return self

    def randInt( self, _i = 0, _j = 1000 ):
        return PyRandom.randint( _i, _j )


    def randFloat( self, _i = 0.0, _j = 1.0 ):
        return PyRandom.uniform( _i, _j )


    def getInteger( self, _i = 0, _j = 1000 ):
        return self.randInt( _i, _j )


    def getFloat( self, _i = 0, _j = 1000 ):
        return self.randFloat( _i, _j )


ALRandom = ALRandom()


##############################################################################


