#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALObject        import ALObject
from ALString        import ALString


class ALStream( ALObject ):
    """
    Parent class for all stream classes - Not to be used

    """

    def __init__( self, _oalString = None ):
        ALObject.__init__( self )
        self.m_oalStreamName = ALString( _oalString )
        self.m_oalStream     = None
        self.m_bIsOpen       = False


    def write( self, _oalObject ):
        """
        Warning: must be changed for other streams like pipes and stdouts...to verify

        """
        self.synchronizeOn()
        if self.m_bIsOpen == True:
            self.m_oalStream.write( _oalObject )
            self.m_oalStream.flush()
        self.synchronizeOff()



 #   def read( self, _iBuffer = 8096 ):
    def read( self ):
        """
        Warning: must be changed for other streams like pipes and stdouts...to verify

        """
        self.synchronizeOn()
        if (self.m_bIsOpen == True):
            obj = self.m_oalStream.read()
        self.synchronizeOff()
        return obj


    def close( self ):
        self.synchronizeOn()
        if (self.m_bIsOpen == True):
 #           self.m_oalStream.flush() # Possible bug on Java-Jython
            self.m_oalStream.close()
            self.m_bIsOpen = False
        self.synchronizeOff()


##############################################################################
