#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython  import *
from ALStream        import ALStream
from ALList          import ALList


class ALStreamFile( ALStream ):
    """
    Class for File streams (text and binary)

    """


    def __init__( self, _oalString, _oalStringFlag = "write" ):
        ALStream.__init__( self, _oalString )
        oalStringFlag = str( _oalStringFlag )

        if ( oalStringFlag.capitalize()=="Write" ):
            oalStringFlag = "w"
        elif ( oalStringFlag.capitalize()=="Append" ):
            oalStringFlag = "a"
        elif ( oalStringFlag.capitalize()=="Read" ):
            oalStringFlag = "r"
        elif ( oalStringFlag.capitalize()=="Writebinnary" ):
            oalStringFlag = "wb"
        elif (oalStringFlag.capitalize()=="Appendbinnary" ): # duvida se funciona
            oalStringFlag = "ab"
        elif ( oalStringFlag.capitalize()=="Readbinnary" ):
            oalStringFlag = "rb"


        self.m_oalStreamFlag = oalStringFlag
        if ( self.m_oalStreamFlag != "a"  and  self.m_oalStreamFlag != "ab" ):
            self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
            self.m_bIsOpen = True;



    def write( self, _oalObject ):
        self.synchronizeOn()
        if ( self.m_oalStreamFlag=="a" ):
            self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
            self.m_oalStream.write( _oalObject )
            self.m_oalStream.close()
        elif( self.m_oalStreamFlag=="w" or self.m_oalStreamFlag=="wb" ):
            self.m_oalStream.write( _oalObject )
        self.synchronizeOff()


    def getLines( self ):
        self.synchronizeOn()
        oalList = None
        if (self.m_bIsOpen == True):
            oalList = ALList( self.m_oalStream.readlines() )
        else:
            self.m_oalStream = open( self.m_oalStreamName, "r" )
            oalList = ALList( self.m_oalStream.readlines() )
            self.m_oalStream.close()
            self.m_bIsOpen = False;
        self.synchronizeOff()
        return oalList


    def readLines( self ):
        return self.getLines()


 #   def read( self, _iBuffer = 8096 ):
    def read( self ):
        """
        Warning: must be changed for other streams like pipes and stdouts...to verify

        """
        self.synchronizeOn()
        oalObject = None
        if (self.m_bIsOpen == True):
            oalObject = self.m_oalStream.read()
        else:
            self.m_oalStream = open( self.m_oalStreamName, "r" )
            oalObject = self.m_oalStream.read()
            self.m_oalStream.close()
            self.m_bIsOpen = False;
        self.synchronizeOff()
        return oalObject


##############################################################################
