#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython   import  *
from ALStream         import ALStream
from ALString         import ALString


class ALStreamSerial( ALStream ):
    """
    Interface to serializing objects in a file.
    """
    def __init__( self, _oalString, _oalStringFlag = "w" ):
        ALStream.__init__( self, _oalString )

        # Workaround to force the binary use of pickle
        if (_oalStringFlag == "w"):
            _oalStringFlag = "wb"
        elif (_oalStringFlag == "r"):
            _oalStringFlag = "rb"
        self.m_oalStreamFlag = ALString( _oalStringFlag )

        self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
        self.m_bIsOpen = True;

        if ( self.m_oalStreamFlag == "wb" ):
            self.m_oPyPickler = PyPickler( self.m_oalStream, 2 )
        elif ( self.m_oalStreamFlag == "rb" ):
            self.m_oPyPickler = PyUnPickler( self.m_oalStream )


    def write( self, _oalObject ):
        self.output( self, _oalObject )


    def input( self ):
        self.synchronizeOn()
        oalObject = None
        if self.m_bIsOpen == True:
            if ( self.m_oalStreamFlag == "rb" ):
                oalObject = self.m_oPyPickler.load()
        self.synchronizeOff()
        return oalObject



    def output( self, _slObject ):
        self.synchronizeOn()
        if self.m_bIsOpen == True:
            if ( self.m_oalStreamFlag == "wb" ):
                self.m_oPyPickler.dump( _slObject )
        self.synchronizeOff()



##############################################################################

