#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython      import *
from ALStream            import ALStream
from ALXml               import ALXml



class ALStreamXml( ALStream ):
    """
    Class for XML streams

    """


    def __init__( self, _oalString, _oalStringFlag = "w" ):
        ALStream.__init__( self, _oalString )
        self.m_oalStreamFlag = _oalStringFlag
        self.m_bIsOpen = False
        self.m_oalStream = None
        if ( self.m_oalStreamFlag == "w" ):
            self.m_oalStream = open( self.m_oalStreamName, self.m_oalStreamFlag )
            self.m_bIsOpen = True;


    def read( self ):
        self.synchronizeOn()
        oalXml = ALXml.createXml( self.m_oalStreamName )
        self.synchronizeOff()
        return oalXml


    def write( self, _oalObject ):
        self.synchronizeOn()
        if ( self.m_oalStreamFlag=="w"):
            # Workaround in from the heritance problem from xml.minidom classes
            # Fixed but necessary to Python legacy stuff
            if (isinstance( _oalObject, PyXmlDocument) ):
                #self.m_oalStream.write( _oalObject.toprettyxml( "\t", "\n", "utf-8" ) ) # bug in Komodo project file
                self.m_oalStream.write( _oalObject.toxml( "utf-8" ) )
            elif ( isinstance( _oalObject, ALXml ) ):
                oPyXmlDocument = _oalObject.getXmlDocument()
                self.m_oalStream.write( oPyXmlDocument.toprettyxml( "\t", "\n", "utf-8" ) )
        self.synchronizeOff()



    # Standart IO
    def input( self ):
        return self.read()


    def output( self, _oalObject ):
        self.write( _oalObject )



##############################################################################
