#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *


##############################################################################
# ALVerbose

class ALTestCaseALDebug( ALTestCase ):

    def testALDebug(self):
        ALVerbose.unitTest( "UnitTest ALDebug:" )

        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeOn()" )
        oBoolStatus = ALDebug.isDebugModeOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )

        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeCommand()" )
        oBoolStatus = ALDebug.isDebugModeCommand()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeForceOn()" )
        oBoolStatus = ALDebug.isDebugModeForceOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )

        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeAssertOn()" )
        oBoolStatus = ALDebug.isDebugModeAssertOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )

        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeVerboseOn()" )
        oBoolStatus = ALDebug.isDebugModeVerboseOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )

        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeLogFileOn()" )
        oBoolStatus = ALDebug.isDebugModeLogFileOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModeActionOn()" )
        oBoolStatus = ALDebug.isDebugModeActionOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugModePluginOn()" )
        oBoolStatus = ALDebug.isDebugModePluginOn()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugLogFile()" )
        ALDebug.setDebugLogFile( "BatateDebugFileName.log" )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.isDebugLogFile()" )
        oBoolStatus = ALDebug.isDebugLogFile()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.getDebugLogFileName()" )
        oBoolStatus = ALDebug.getDebugLogFileName()
        ALVerbose.unitTest( "Result: " + ALString( oBoolStatus ) )


        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugModeOn()" )
        ALDebug.setDebugModeOn()

        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugModeOff()" )
        ALDebug.setDebugModeOff()


        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugProfileOn()" )
        ALDebug.setDebugProfileOn()


        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugProfileOff()" )
        ALDebug.setDebugProfileOff()


        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugVerboseOn()" )
        ALDebug.setDebugVerboseOn()



        ALVerbose.unitTest( "Testing the Static Method ALDebug.setDebugPluginOn()" )
        ALDebug.setDebugPluginOn()









        ALVerbose.unitTest( )


    def testALDebugError(self):
        ALVerbose.unitTest( "UnitTest ALDebug::testALDebugError" )

        forceAndError()
        ALVerbose.unitTest( )



##############################################################################

    def process( self ):
        self.addTestMethod( self.testALDebug )
        self.addTestMethod( self.testALDebugError )
        self.addTestMethod( self.testALDebug )



##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALDebug = ALTestCaseALDebug( "TestCase ALDebug" )
    oalTestCaseALDebug.execute()
