#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALLogFile( ALTestCase ):
    """
    TestSuite for ALTestCaseALLogFile
    """
    def testALLogFile( self ):
        ALVerbose.unitTest( "Test ALLogFile" )

        oalLogFile = ALLogFile()
        oalLogFile.log( "  [!!!!!!!] Testing the basic log file 1 \n" )
        oalLogFile.log( "  [!!!!!!!] Testing the basic log file 2 \n" )
        oalLogFile.log( "  [!!!!!!!] Testing the basic log file 3 \n" )
        oalLogFile.getProfileFile()
        del oalLogFile

        ALVerbose.unitTest( )




    def testALLogFileGeneric( self ):
        ALVerbose.unitTest( "Test ALLogFile" )

        oalLogFile = ALLogFile( "TestingLogFileGeneric.log", True, True )
        oalLogFile.addLog( "  [!!!!!!!] Testing the Generic log file 1 \n" )
        oalLogFile.addLog( "  [!!!!!!!] Testing the Generic log file 2 \n" )
        oalLogFile.addLog( "  [!!!!!!!] Testing the Generic log file 3 \n" )

        oalLogFile.outputProfileFile()

        del oalLogFile

        ALVerbose.unitTest( )



    def testALLogFileAction( self ):
        ALVerbose.unitTest( "Test ALLogFile" )

        oalAction = ALAction()

        ALVerbose.screenID( oalAction.getID(), " Testing the output log individual for each action 1" )
        ALVerbose.screenID( oalAction.getID(), " Testing the output log individual for each action 2" )
        ALVerbose.screenID( oalAction.getID(), " Testing the output log individual for each action 3" )

        ALVerbose.outputActionLog( oalAction.getID() )
        ALVerbose.outputActionLog( oalAction.getID(), "TestOutputLogActionSpecialName.log"  )

        oalLogFile = ALLogFile()
        oalLogFile.outputProfileFile( "TestOutputLogActionSpecialName.log" )
        del oalLogFile


        ALVerbose.unitTest( )



##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALLogFile )
        self.addTestMethod( self.testALLogFileGeneric )
        self.addTestMethod( self.testALLogFileAction )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALLogFile = ALTestCaseALLogFile( "TestCase ALLogFile" )
    oalTestCaseALLogFile.execute()
