#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *




#===============================================================================
#Plugins for multiaction application and ApplicationActionControl Test
#===============================================================================

class TestPlugin01( ALPlugin ):

    def __init__( self ):
        ALPlugin.__init__( self )

    def process( self, oalObject = None ):
        self.synchronizeOn()
        ALVerbose.screenID( self.getID(), "Running TestPlugin01010101" )
        self.synchronizeOff()



class TestPlugin02( ALPlugin ):

    def __init__( self ):
        ALPlugin.__init__( self, "tokenPlugin02" )

    def process( self, _oalObject = None ):
        self.synchronizeOn()
        ALVerbose.screenID( self.getID(), "Running TestPlugin02020202" )
        self.synchronizeOff()


    def methodTest( self, _oalObject = None ):
        ALVerbose.screenID( self.getID(), "Running TestPlugin02020202---TEST" )


class TestPlugin03( ALPlugin ):

    def process( self, _oalObject = None ):
        self.synchronizeOn()
        ALVerbose.screenID( self.getID(), "Running TestPlugin   ||||" + self.getToken() )
        self.synchronizeOff()


class TestPlugin04( TestPlugin03 ):
    pass


class TestPlugin05( ALPlugin ):

    def process( self, _oalObject = None ):
        self.synchronizeOn()

        self.synchronizeOff()

        ALVerbose.screenID( self.getID(), "Running TestPlugin   ||||" + self.getToken() )

        self.synchronizeOn()
        for i in range(0, 10000):
            j = i
        ALVerbose.screenID( self.getID(), "Total Iteraction 1: " + ALString( j ) )
        for i in range(0, 100000):
            j = i
        ALVerbose.screenID( self.getID(), "Total Iteraction 2: " + ALString( j ) )
        for i in range(0, 100000):
            j = i
        ALVerbose.screenID( self.getID(), "Total Iteraction 3: " + ALString( j ) )
        self.synchronizeOff()




class TestPlugin06( ALPlugin ):

    def process( self, _oalObject = None ):
        self.synchronizeOn()
        oalPlugin5 = TestPlugin05()
        oalPlugin5.executePlugin()

        ALVerbose.unitTest( "Running Plugin 5 - in 6" )
        oalPlugin = TestPlugin05()
        oalPlugin.executePlugin()

        oalPlugin5.synchronizePlugin()
        oalPlugin.synchronizePlugin()
        ALVerbose.unitTest( "Running Plugin 5 - in 6" )
        self.synchronizeOff()



class TestPlugin07( ALPlugin ):

    def process( self, _oalObject = None ):
        self.synchronizeOn()
        oalPlugin = TestPlugin06()
        oalPlugin.executePlugin()
        ALVerbose.unitTest( "Running Plugin 6 - in 7" )
        oalPlugin5 = TestPlugin05()
        oalPlugin5.executePlugin()
        ALVerbose.unitTest( "Running Plugin 5 - in 7" )
        oalPlugin6 = TestPlugin06()
        oalPlugin6.executePlugin()
        oalPlugin.synchronizePlugin()
        oalPlugin5.synchronizePlugin()
        oalPlugin6.synchronizePlugin()

        ALVerbose.unitTest( "Running Plugin 6 - in 7" )
        self.synchronizeOff()




class ALTestCaseALPlugin( ALTestCase ):
    """
    TestSuite for ALPlugin
    """
    def testALPlugin( self ):
        ALVerbose.unitTest( "Test ALPlugin" )

        oalPlugin7 = TestPlugin07()
        oalPlugin7.executePlugin()
        oalPlugin7.synchronizePlugin()

        ALVerbose.unitTest( )



##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALPlugin )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALPlugin = ALTestCaseALPlugin( "TestCase ALPlugin" )
    oalTestCaseALPlugin.execute()
