#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALSignal( ALTestCase ):
    """
    TestSuite for ALSignal
    """
    def testALSignal( self ):
        ALVerbose.unitTest( "UnitTest ALSignal:" )

        oalSignal = ALSignal()
        ALVerbose.unitTest( "Signal      : " + ALString( oalSignal.getSignal() ) )
        ALVerbose.unitTest( "Signal Token: " + ALString( oalSignal.getSignalToken() ) )

        oalArgument = ALArgument( [ "--cB", "--cA", "--cC" ] )
        oalSignal.setArgument( oalArgument )

        ALVerbose.unitTest( "Signal Argument: " + ALString( oalSignal.getArgument() ) )

        oalArgument = ALArgument( [ "--couou", "--error" ] )
        oalSignal = ALSignal.error()
        ALVerbose.unitTest( "Signal      : " + ALString( oalSignal.getSignal() ) )
        ALVerbose.unitTest( "Signal Token: " + ALString( oalSignal.getSignalToken() ) )
        oalSignal.setArgument( oalArgument )

        ALVerbose.unitTest( "Signal Argument: " + ALString( oalSignal.getArgument() ) )
        ALVerbose.unitTest( "Signal Argument First: " + ALString( oalSignal.getArgumentNumber() ) )
        oalArgument = oalSignal.getArgument()
        ALVerbose.unitTest( "Fisrt  Argument: " + ALString( oalArgument.getArgumentNumber( 0 ) ) )


        oalObjectSignal = ALApplication.getSignal()
        ALVerbose.unitTest( "Signal Appli Original  : " + ALString( oalObjectSignal.getSignal() ) )

        oalSignalError = ALSignal.error()

        ALApplication.setSignal( oalSignalError )
        oalObjectSignal = ALApplication.getSignal()
        ALVerbose.unitTest( "Signal Appli           : " + ALString( oalObjectSignal.getSignal() ) )

        oalSignalOk = ALSignal.ok()

        ALApplication.setSignal( oalSignalOk )

        ALVerbose.unitTest()


##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALSignal )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALSignal = ALTestCaseALSignal( "TestCase ALSignal" )
    oalTestCaseALSignal.execute()
