#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *


##############################################################################
# ALString

class ALTestCaseALString( ALTestCase ):

    def testALString(self):
        ALVerbose.unitTest( "UnitTest ALString" )

        print "\nUnitTest ALString:\n"

        oalString0 = ALString( "Test ALString" )
        print "Getting String: " + oalString0
        #print "Equal banane String: " + oalString0.equals( "banane" )

        oalString1  = oalString0.duplicate()
        oalString1a = oalString0

        print "Test duplicate: " + oalString1
        print "Test egal: " + str( oalString0.equals( oalString1 ) )
        print "Test if same instance 1: " + str( oalString0 is oalString1 )
        print "Test if same instance 2: " + str( oalString0 is oalString1a )

        print " printing empty string: " + ALString.empty()

        oalString2 = ALString( "oooOOOooo" )
        print "Test upperCase: " + oalString2 + " after capitalize: " + oalString2.capitalize()

        print "\nEnd UnitTest ALString \n\n"

        print "Test getToken()\n"
        oalString1 = ALString( "Ma chaine a moi qu'elle est belle!")
        print oalString1.getToken( 3 )


        print "\nTest upper()"
        oalString1 = ALString( "bbbuuuuuu")
        print oalString1.upper()

        print "\nTest atoi()"
        oalString1 = ALString( "1.00582")
        print oalString1.atoi()

        print "\nTest atof()"
        oalString1 = ALString( "88")
        print oalString1.atof()


        print "\nTest replace()"
        oalString1 = ALString( "88bcnhcnbn")
        print oalString1
        oalString1 = oalString1.replace( "88", "ReplaceInTheString--" )
        print oalString1


        print "\nTest split()"
        oalString1 = ALString( "Test if same instance 1: ")
        print oalString1.split()

        print "\nTest getToken()"
        print oalString1.getToken( 3 )

        print "\nTest existSubString()"
        if (oalString1.existSubString( "Test" )==True):
            print "Exist token test"

        print "\nTest cleanXml()"
        print oalString1.cleanXml( )


        print "\nTest getPythonString() to compare the types"
        print type( oalString1 )
        print type( oalString1.getPythonString() )

        ALVerbose.unitTest()




    def testALStringAdvanced( self ):
        ALVerbose.unitTest( "UnitTest ALStringAdvanced" )

        oalString1 = ALString( "Ma chaine a moi qu'elle est belle!")
        ALAssert.equal( "moi", oalString1.getToken( 3 ))
        ALAssert.equal( None, oalString1.getToken( 10 ))

        ALAssert.equal("chaine", oalString1.getNextToken ("Ma"))
        ALAssert.equal("moi", oalString1.getNextToken ("a"))
        ALAssert.equal("belle!", oalString1.getNextToken ("est"))
        ALAssert.equal(None, oalString1.getNextToken ("toto"))
        ALAssert.equal(None, oalString1.getNextToken ("belle!"))

        ALVerbose.unitTest()



##############################################################################

    def process( self ):
        self.addTestMethod( self.testALString )
        self.addTestMethod( self.testALStringAdvanced )



##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALString = ALTestCaseALString( "TestCase ALTime" )
    oalTestCaseALString.execute()
