#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################



from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *


##############################################################################
# ALContainer

class ALTestCaseALTime( ALTestCase ):

    def testALTime(self):
        ALVerbose.unitTest( "UnitTest ALTime" )

        oalTime = ALTime()

        oalTime.initTime()
        ALVerbose.unitTest( " duration: " + ALString( oalTime.getDuration() ) )

        oalTime.initTime()
        ALTime.wait( 2.0 )
        ALVerbose.unitTest( " duration: " + ALString( oalTime.getDuration() ) )


        oalTime2 = ALTime()

        ALTime.wait( 2.55 )
        ALVerbose.unitTest( " duration: " + ALString( oalTime2.getDuration() ) )


        ALTime.wait( 3.55 )
        ALVerbose.unitTest( " duration: " + ALString( oalTime2.getDuration() ) )
        ALVerbose.unitTest()

        ALTime.wait( 2.5555 )
        ALVerbose.unitTest( "Testing the Static Method ALTime.getTimeStringPSP()" )
        ofTime = oalTime2.getDuration()
        ALVerbose.unitTest( "Floating Time in Seconds: " + ALString( ofTime ) )
        oalTime = ALTime.getTimeStringPSP( ofTime )
        ALVerbose.unitTest( "       Formated Time PSP: " + oalTime )

        ofTime = 90061.001
        ALVerbose.unitTest( "Floating Time in Seconds: " + ALString( ofTime ) )
        ALVerbose.unitTest( "      The good answer is: 01d:01h:01m:01s:001ms" )
        oalTime = ALTime.getTimeStringPSP( ofTime )
        ALVerbose.unitTest( "       Formated Time PSP: " + oalTime )

        ofTime = 999999.890
        ALVerbose.unitTest( "Floating Time in Seconds: " + ALString( ofTime ) )
        oalTime = ALTime.getTimeStringPSP( ofTime )
        ALVerbose.unitTest( "       Formated Time PSP: " + oalTime )


        ofTime = AL_TIME_INFINITE
        ALVerbose.unitTest( "Floating Time in Seconds: " + ALString( ofTime ) )
        oalTime = ALTime.getTimeStringPSP( ofTime )
        ALVerbose.unitTest( "       Formated Time PSP: " + oalTime )


        ALVerbose.unitTest()



##############################################################################

    def process( self ):
        self.addTestMethod( self.testALTime )



##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALTime = ALTestCaseALTime( "TestCase ALTime" )
    oalTestCaseALTime.execute()
