#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################



from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *
from ALDefinition        import *


##############################################################################
# ALVerbose

class ALTestCaseALVerbose( ALTestCase ):

    def outputLoop( self ):
        limit = 1000
        for i in range( 1, limit ):
            ALVerbose.screen( i, limit )
        limit = 10000
        for i in range( 1, limit ):
            ALVerbose.screen( i, limit )

    def testALVerbose( self ):

        ALVerbose.unitTest( "UnitTest ALVerbose:" )

# Error in the multimethod - it must be studied
#        ALVerbose.error()
#        ALVerbose.screen()
#        ALVerbose.warning()
#        ALVerbose.DEBUG()


        ALVerbose.screen( "Testing the verbose controls...." )
        ALVerbose.screen( "Log File output Option is ON" )
        ALVerbose.setLogFileOn( )
        ALVerbose.screen( "log is ON 1" )
        ALVerbose.setLogFileOff( )
        ALVerbose.screen( "log is OFF" )
        ALVerbose.setLogFileOn( )
        ALVerbose.screen( "log is ON 2" )
        #self.outputLoop()

        ALVerbose.setVerboseOff()
        ALVerbose.screen( "log is FORCED off" )
        ALVerbose.DEBUG( "Test information DEBUG off" )
        ALVerbose.setVerboseDebugOn()
        ALVerbose.screen( "log is FORCED on" )
        ALVerbose.DEBUG( "Test information DEBUG on" )
        ALVerbose.setVerboseDebugOff()
        ALVerbose.DEBUG( "Test information DEBUG off" )
        ALVerbose.screen( "log is OFF FINAL" )
        ALVerbose.screen( "log is FORCED on" )
        ALVerbose.setVerboseDebugOn()

        ALVerbose.setVerboseDebugOff()
        ALVerbose.DEBUGID(  self.getID(),"Test information DEBUG off" )
        ALVerbose.screenID( self.getID(),"log is OFF FINAL" )
        ALVerbose.errorID(  self.getID(),"log is FORCED on" )
        ALVerbose.warningID(self.getID(),"log is FORCED on" )
        ALVerbose.setVerboseDebugOn()

        ALVerbose.setVerboseOn()
        ALVerbose.ASSERT( "ASSERT test" )



    def testALVerboseDictionary( self ):
        ALVerbose.unitTest( "UnitTest ALVerbose Action:" )


        ALVerbose.screen( "Testing the verbose dictionary for actions...." )

        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = all...." )

        ALVerbose.screenID( self.getID(), "log is ON 1" )
        ALVerbose.screenID( self.getID(), "log is ON 2" )
        ALVerbose.screenID( self.getID(), "log is ON 1" )
        ALVerbose.screenID( self.getID(), "log is ON 4" )
        ALVerbose.warningID( self.getID(), "log is ON 1" )
        ALVerbose.screenID( self.getID(), "log is ON 5" )
        ALVerbose.warningID( self.getID(), "log is ON 1" )
        ALVerbose.DEBUGID( self.getID(), "log is ON 5" )
        ALVerbose.DEBUGID( self.getID(), "log is ON 1" )
        ALVerbose.DEBUGINDEXID( self.getID(), 50, 100 )
        ALVerbose.DEBUGINDEXID( self.getID(), 60, 100 )
        ALVerbose.screenIndexID( self.getID(), 50, 100 )
        ALVerbose.screenIndexID( self.getID(), 60, 100 )


        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = aalib...." )
        ALVerbose.DEBUGID( self.getID(), "log is ON 5", AL_DEBUG_TAG_AALIB)
        ALVerbose.DEBUGID( self.getID(), "log is ON 1", AL_DEBUG_TAG_AALIB )
        ALVerbose.DEBUGINDEXID( self.getID(), 50, 100, AL_DEBUG_TAG_AALIB )
        ALVerbose.DEBUGINDEXID( self.getID(), 60, 100, AL_DEBUG_TAG_AALIB )

        ALVerbose.outputObjectsDEBUG()



    def testALVerboseDebugTag( self ):
        ALVerbose.DEBUG( "USED tag = test....", "test" )
        ALVerbose.DEBUGID( self.getID(), "log is ON 5 - TAG=test", "test" )
        ALVerbose.DEBUGINDEXID( self.getID(), 50, 100, "test" )
        ALVerbose.DEBUGINDEXID( self.getID(), 60, 100, "test" )
        ALVerbose.DEBUGINDEXID( self.getID(), 101, 100, "test" )

        ALVerbose.aalibDEBUGID( self.getID(), "testing 1 TAG = aalib" )
        ALVerbose.aalibDEBUG( "testing 2 TAG = aalib" )

        ALVerbose.DEBUGID( self.getID(), "testing TAG = all", AL_DEBUG_TAG )



    def testALVerboseDebugTagControl( self ):
        ALVerbose.unitTest( "UnitTest ALVerbose Tag:" )

        if (ALDebug.isDebugModeOn()==True):
            ALVerbose.screen( "Debug Mode is ON - Testing features...." )
        else:
             ALVerbose.screen( "Debug Mode is OFF - Not running test...." )
             return

        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = From Command Line...." )
        ALVerbose.screen( ALVerbose.getDebugTag() )
        self.testALVerboseDebugTag()

        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = all...." )
        ALVerbose.setDebugTag( AL_DEBUG_TAG )
        self.testALVerboseDebugTag()

        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = test...." )
        ALVerbose.setDebugTag( "test" )
        self.testALVerboseDebugTag()

        ALVerbose.screen( "Testing the verbose DEBUG tags :: tag = aalib...." )
        ALVerbose.setDebugTag( AL_DEBUG_TAG_AALIB )
        self.testALVerboseDebugTag()






##############################################################################

    def process( self ):
#        self.addTestMethod( self.testALVerbose )
#        self.addTestMethod( self.testALVerboseDictionary )
        self.addTestMethod( self.testALVerboseDebugTag )
        self.addTestMethod( self.testALVerboseDebugTagControl )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALVerbose = ALTestCaseALVerbose( "TestCase ALVerbose" )
    oalTestCaseALVerbose.execute()
