#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALXsdDataBinding( ALTestCase ):
    """
    TestSuite for ALXsdDataBinding
    """


    def testALXsdObjectDirect( self ):
        ALVerbose.unitTest( "Test ALTestCaseALXsdDataBinding" )

        oalStrXsdInputFile = ALString( "./DataForTests/people.xsd")
        oalStrXmlInputFile = ALString( "./DataForTests/people.xml" )


        ALVerbose.unitTest( "Testing the people.xsd import module people.py" )
        oalXsdDataBinding3 = ALXsdDataBinding( oalStrXsdInputFile )
        oalObject3 = oalXsdDataBinding3.getObject( oalStrXmlInputFile )
        oalObject3.outputFile( "testOuputPeopleXsd03.xml" )


        ALVerbose.unitTest( "Testing the people.xsd import module module_people4.py" )
        oalStrPyOutputFile = ALString( "module_people4.py" )
        oalXsdDataBinding4 = ALXsdDataBinding( oalStrXsdInputFile, oalStrPyOutputFile )
        oalObject4 = oalXsdDataBinding4.getObject( oalStrXmlInputFile )
        oalObject4.outputFile( "testOuputPeopleXsd04.xml" )


        ALVerbose.unitTest( "Testing the people.xsd import module module_people5.py" )
        oalStrPyOutputFile = ALString( "module_people5.py" )
        oalXsdDataBinding5 = ALXsdDataBinding( oalStrXsdInputFile )
        oalObject5 = oalXsdDataBinding5.getObject( oalStrXmlInputFile, oalStrPyOutputFile )
        oalObject5.outputFile( "testOuputPeopleXsd05.xml" )


        ALVerbose.unitTest( "Testing the empty instance of the object" )
        ALVerbose.unitTest( "Testing the people.xsd import module module_people6.py" )
        oalStrPyOutputFile = ALString( "module_people6.py" )
        oalXsdDataBinding6 = ALXsdDataBinding( oalStrXsdInputFile, oalStrPyOutputFile )
        oalObject6 = oalXsdDataBinding6.getObjectClass( "people" )
        # oalObject6.setToken00()
        # oalObject6.set.....
        oalObject6.outputFile( "testOuputPeopleXsd06.xml" )


        oalObject7 = oalXsdDataBinding3.getObjectClass( "person" )
        # oalObject7.setToken00()
        # oalObject7.set.....
        oalObject7.outputFile( "testOuputPERSONXsd07.xml" )


        ALVerbose.unitTest()




##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALXsdObjectDirect )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALXsdDataBinding = ALTestCaseALXsdDataBinding( "TestCase ALXsdDataBinding" )
    oalTestCaseALXsdDataBinding.execute()
