#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem              import *
from ALTestSuiteSystem           import ALTestSuiteSystem
from ALTestSuiteKernel           import ALTestSuiteKernel



class ALTestSuiteAll( ALTestSuite ):


    def process( self ):
        self.addTestMethod( ALTestSuiteSystem().execute )
        self.addTestMethod( ALTestSuiteKernel().execute )



##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

#    # Force DEBUG mode on
#    ALDebug.setDebugLogFile( "UniqueLogFile.log" )
#    ALDebug.setDebugVerboseOn()
#    ALDebug.setDebugModeOn()
#    ALDebug.setDebugModeForceOn()
#    ALDebug.setDebugProfileOff()

    oalTestSuiteAll = ALTestSuiteAll( "ALTestSuiteAll" )
    oalTestSuiteAll.execute()


##############################################################################
