#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython            import *
from ALObject                  import ALObject
from ALSystem                  import ALSystem
from ALVerbose                 import ALVerbose
from ALTime                    import ALTime
from ALString                  import ALString
from ALList                    import ALList
from ALDiskExplorer            import ALDiskExplorer


class ALTrace( ALObject ):
    """
    Interface for AL trace objects.
    """
    def __init__( self ):
        ALObject.__init__( self )


    def trace( _oalObject = None, _oBoolScreen = True ):
        """
        This method to trace the data.
        """
        oalListTrace = ALList()
        oalListTrace.add( ALString( "ERROR TRACE Information :" ) )

        # Bypass Jython Bug in the if operator
#        oBoolJythonBug = False
#        try:
#            if (_oalObject != None):
#                oBoolJythonBug = True
#        except:
#            pass
        oBoolJythonBug = False
        if (_oalObject is not None):
            oBoolJythonBug = True

        if (oBoolJythonBug == True):
            oalListTrace.add( ALString( _oalObject.getName() + "::EXCEPTION" ) )
            oalListTrace.add( ALString( "EXCEPTION objectID:: " + _oalObject.getID() ))


        (exc_type, exc_value, exc_traceback) = ALSystem.exc_info()
        list = PyTraceback.extract_tb( exc_traceback )
        for line in list:
            oalListTrace.add( ALString( "File  :: " + ALString( ALDiskExplorer.normPath( line[0] ) ) ) )
            oalListTrace.add( ALString( "Method:: " + ALString( line[2] ) ) )
            oalListTrace.add( ALString( "Line  :: " + ALString( line[1] ) ) )
            oalListTrace.add( ALString( "Object:: " + ALString( line[3] ) ) )
        oalStringErrorMessage = ALString( PyTraceback.format_exception_only( exc_type, exc_value )[0][:-1] )
        oalListTrace.add( ALString( oalStringErrorMessage ) )

        if (oBoolJythonBug == True):
            if (_oBoolScreen == True ):
                for i in oalListTrace:
                    ALVerbose.errorID( _oalObject.getID(), i )
            else:
                for i in oalListTrace:
                    ALVerbose.logID( _oalObject.getID(),  " [ERROR]: " + i  )
        else:
            if (_oBoolScreen == True ):
                for i in oalListTrace:
                    ALVerbose.error( i )
            else:
                for i in oalListTrace:
                    ALVerbose.log(  " [ERROR]: " + i  )

        exc_traceback = None
    trace = staticmethod( trace )



##############################################################################