#
#    Project: EDNA MXv1
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuitePluginExecuteInterfacev10.py 698 2009-05-11 10:43:08Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal author:       Marie-Francoise Incardona (incardon@esrf.fr)
#
#    Contributing author:    Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib                                  import EDCompiler
from EDTestSuite                                  import EDTestSuite

class EDTestSuitePluginExecuteInterfacev10( EDTestSuite ):
        

    def process( self ):
        """
        """
        #self.addTestCaseFromName( "EDTestCasePluginExecuteCCP4iv10" )
        self.addTestCaseFromName( "EDTestCasePluginExecuteCCP4iv10_withDataSetInput" )
        self.addTestCaseFromName( "EDTestCasePluginExecuteSubWedgeMergev10" )
        self.addTestCaseFromName( "EDTestCasePluginExecuteControlSubWedgeAssemblev10" )
        self.addTestCaseFromName( "EDTestCasePluginExecuteControlSubWedgeAssemblev10NineImageSubWedge" )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestSuitePluginExecuteInterfacev10 = EDTestSuitePluginExecuteInterfacev10( "EDTestSuitePluginExecuteInterfacev10" )
    edTestSuitePluginExecuteInterfacev10.execute()

##############################################################################