#
#    Project: EDNA MXv1
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuitePluginUnitMXv1.py 749 2009-05-29 12:44:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors:      Marie-Francoise Incardona (incardon@esrf.fr)
#                            Olof Svensson (svensson@esrf.fr) 
#
#    Contributing author:    Karl Levik (karl.levik@diamond.ac.uk)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib           import EDCompiler

from EDTestSuite           import EDTestSuite


class EDTestSuitePluginUnitMXv1( EDTestSuite ):
        

    def process( self ):
        """
        """
        self.addTestCaseFromName( "EDTestCaseEDHandlerMOSFLMv10" )
        self.addTestCaseFromName( "EDTestCaseEDHandlerLabelitv10" )
        self.addTestCaseFromName( "EDTestCaseEDHandlerRaddosev10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitControlIndexingv10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitControlIntegrationv10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitStrategyv10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitControlCharacterisationv10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitReadImageHeaderv10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitInterfacev10" )
        self.addTestSuiteFromName( "EDTestSuitePluginUnitISPyBv10" )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestSuitePluginUnitMXv1 = EDTestSuitePluginUnitMXv1( "EDTestSuitePluginUnitMXv1" )
    edTestSuitePluginUnitMXv1.execute()

##############################################################################